#version 430 core

in vec3 normal;
layout(location = 0) in vec3 position;
in vec3 diffuseColor;

out vec3 worldNormal;
out vec4 worldPosition;
out mat4 inverseView;
out vec3 fragDiffuseColor;
out vec4 smCoords;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 M_Vl_Pl_L_Matrix; /* (L * Pl * Vl * M) for shadow mapping */

void main() {
	fragDiffuseColor = diffuseColor;

	mat3 normalModel = mat3(model[1][1]*model[2][2]-model[1][2]*model[2][1],	model[1][2]*model[2][0]-model[1][0]*model[2][2],	model[1][0]*model[2][1]-model[1][1]*model[2][0],
							model[0][2]*model[2][1]-model[0][1]*model[2][2],	model[0][0]*model[2][2]-model[0][2]*model[2][0],	model[0][1]*model[2][0]-model[0][0]*model[2][1],
							model[0][1]*model[1][2]-model[0][2]*model[1][1],	model[0][2]*model[1][0]-model[0][0]*model[1][2],	model[0][0]*model[1][1]-model[0][1]*model[1][0]);

	worldNormal = normalize(normalModel * normal);

	worldPosition = model * vec4(position, 1);
	inverseView = inverse(view);

	gl_Position = projection * view * model * vec4(position, 1);
	smCoords = M_Vl_Pl_L_Matrix * vec4(position, 1);
}
